#!/bin/sh

echo ""
echo "#----------------------------------------------------------------------"
echo "# POLICENAUTS Sega Saturn Patch Script for Mac OS X"
echo "#----------------------------------------------------------------------"
echo "# Make sure that the following files are all in the same folder as"
echo "# this bash script:"
echo "# - POLICENAUTS_1.bin, POLICENAUTS_2.bin, POLICENAUTS_3.bin"
echo "# - POLICENAUTS_1.cue, POLICENAUTS_2.cue, POLICENAUTS_3.cue"
echo "# - NautsSaturnENG-CD1.XDELTA, NautsSaturnENG-CD2.XDELTA,"
echo "#   NautsSaturnENG-CD3.XDELTA"
echo "#----------------------------------------------------------------------"
echo ""
read -n 1 -s -p "Press any key to continue"
echo ""

echo ""
echo "---- Checking for required files..."
echo ""
sleep 1

for i in {1..3};
do
   if [[ -e "POLICENAUTS_$i.bin" ]]; then
      echo "POLICENAUTS_$i.bin ......................................... PASS"
	  sleep .2
   else
      echo "POLICENAUTS_$i.bin ......................................... FAIL"
      sleep 2
      exit 1
   fi
   
   if [[ -e "POLICENAUTS_$i.cue" ]]; then
      echo "POLICENAUTS_$i.cue ......................................... PASS"
	  sleep .2
   else
      echo "POLICENAUTS_$i.cue ......................................... FAIL"
      sleep 2
      exit 1
   fi
   
   if [[ -e "NautsSaturnENG-CD$i.XDELTA" ]]; then
      echo "NautsSaturnENG-CD$i.XDELTA ................................. PASS"
	  sleep .2
   else
      echo "NautsSaturnENG-CD$i.XDELTA ................................. FAIL"
      sleep 2
      exit 1
   fi
done

echo ""
echo "---- Creating folders"
sleep 1
mkdir -p "Original Files"
mkdir -p "Patched Files"

for i in {1..3};
do 

echo ""
echo "---- Converting bin/cue to iso/wav for disc $i"
echo ""
sleep 1
bchunk -w POLICENAUTS_$i.bin POLICENAUTS_$i.cue POLICENAUTS_$i-

echo ""
echo "---- Patching disc $i"
sleep 1
xdelta3 -f -d -s POLICENAUTS_$i-01.iso NautsSaturnENG-CD$i.XDELTA "Patched Files"/POLICENAUTS_$i-1.ENGLISH.iso

echo "---- Cleaning up"
echo ""
sleep 1
mv POLICENAUTS_$i-02.wav "Patched Files"/POLICENAUTS_$i-2.wav
rm POLICENAUTS_$i-01.iso

done

cp POLICENAUTS_*.ENGLISH.cue "Patched Files"/
find . -name . -o -type d -prune -o -exec sh -c 'mv "$@" "$0"' "Original Files"/ {} +
